stages:
  - style
  - test

include:
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml

.container:
  image: php:8.1
  cache:
    paths:
      - vendor/
  before_script:
    - apt-get update -yqq
    - apt-get install zip unzip git -yqq
    - pecl install xdebug
    - docker-php-ext-enable xdebug
    - php --ini
    - echo 'short_open_tag=0' >> /usr/local/etc/php/conf.d/ci.ini
    - echo 'xdebug.mode=coverage' >> /usr/local/etc/php/conf.d/ci.ini
    - php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
    - php composer-setup.php
    - php -r "unlink('composer-setup.php');"
    - php composer.phar install

psalm:
  stage: style
  extends: .container
  allow_failure: true
  only:
    - merge_requests
  except:
    - tags
  cache:
    paths:
      - psalm/
  script:
    - php vendor/bin/psalm

phpstan:
  stage: style
  extends: .container
  allow_failure: true
  only:
    - merge_requests
  except:
    - tags
  cache:
    paths:
      - phpstan/
  script:
    - php vendor/bin/phpstan analyze

php-cs-fixer:
  stage: style
  extends: .container
  allow_failure: true
  only:
    - merge_requests
  except:
    - tags
  script:
    - php ./vendor/bin/pint --test

test:
  stage: test
  extends: .container
  cache:
    paths:
      - .phpunit.result.cache
  except:
    - tags
  only:
    - merge_requests
  script:
    - vendor/bin/phpunit --coverage-text --colors=never
  coverage: '/^\s*Lines:\s*\d+.\d+\%/'

